require "samenessed/version"
require "active_resource"

module Samenessed
  autoload :Subject, File.expand_path('../samenessed/subject', __FILE__)
  autoload :Principal, File.expand_path('../samenessed/principal', __FILE__)  
  
  @site
  @user
  @password
  
  def self.load_config_file(filepath)
    config = YAML.load(File.read(filepath))[Samenessed.env]
    @site = config["site"]
    @user = config["user"]    
    @password = config["password"]
    init_class_connections
    return config
  end

  def self.load_config_from_hash(hash)
    @site = hash[:site]
    @user = hash[:user]
    @password = hash[:password]
    init_class_connections
    return hash
  end
  
  def self.env
    env = ENV['SAMENESSED_ENV'] || 'development'
    env
  end
  
  def self.site
    @site
  end
  
  def self.user
    @user
  end
  
  def self.password
    @password
  end
  
  private 
  
  def self.init_class_connections
    Samenessed::Principal.site = site
    Samenessed::Principal.user = user
    Samenessed::Principal.password = password
    
    Samenessed::Subject.site = site
    Samenessed::Subject.user = user
    Samenessed::Subject.password = password
  end
  
end
